﻿/*
Название: SelectAndPlaceImage.jsx
Приложение для использования: Adobe InDesign CS3, CS4, CS5, CS6
Версия: 1.2
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Помещает изображение в выделенные графические фреймы. 
Возможно помещение изображения в несколько выделенных фреймов.
Может быть использован как дополнение для скрипта MakeImposition.jsx.
Техническая поддержка: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
===================================================
Name: SelectAndPlaceImage.jsx
Application to use with: Adobe InDesign CS3, CS4, CS5, CS6
Version: 1.2
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Functions: Places image into selected graphic frames.
Placement into multiple selection is possible.
Can be used as an addition for MakeImposition.jsx script.
Technical support: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
*/
//
// описание глобальных переменных
//
// весрсия скрипта
var VERSION = "1.2";
// название скрипта
var TITLE = "SelectAndPlaceImage v."+VERSION;
// активный документ
var AD; 
// имя активного документа
var D_NAME = ""; 
// путь активного документа
var AD_PATH = "";
// был ли сохренен документ
var AD_SAVED = false;
// сокращенное имя активного документа
var D_NAME_SHORT = ""; 
// длина имени файла для диалога
var D_NAME_LEN;
 // ссылка на активный разворот	
var AS;	
// начальное окно (для восстановления)
var BEGIN_WINDOW; 
// режим помещения изображений
var MODE; 
// начальное значение режима помещения изображений
var MODE_INI = 1;
// текст соответствующий выбранному режиму помещения изображений 
var MODE_TEXT = "Process mode: ";
// список режимов помещения изображений
var MODE_LIST =
[
	"Step-by-step", // 0
	"Auto" // 1
];
// автоматический режим помещения изображений
var AUTO = false;
// путь файла с изображением
var FILE_PATH = "";
// имя файла с изображением
var FILE_NAME = "";
// сокращенное имя файла с изображением
var FILE_NAME_SHORT = "";
// файл с изображением
var FILE; 
// команда на выполнение операции
var PLACE = true; 
// команда на выполнение операции из пошагового диалога
var PLACE_DIAL_STEP = true;
// число пропущенных фреймов
var N_SKIP = 0; 
// число фреймов, в которые помещено изображение
var N_PLACED = 0;  
// показывать стандартный диалог помещения
var SHOW_PLACEMENT_OPTIONS;
// текст для опции показывать стандартный диалог помещения
var SHOW_PLACEMENT_OPTIONS_TEXT = "Show placement options";
// возможность отобразить изображение
var CAN_SHOW = false; 
 // файловая система
var WFS = false;
// Количество ошибок
var N_ERR = 0; 
// выход из диалога замены
var QUIT_BY_USER = false;
// опции фиттинга
var FIT;
// опции фиттинга
var FIT_OPTION_LIST = 
[
	"Use Prefences settings", // 0
	"Fit content to frame", // 1
	"Fit content to frame proportionally", // 2
	"Fit frame to content", // 3
	"Fill frame proportionally", // 4
	"100% content scaling", // 5
	"Specified content scaling", //6
	"Specified content size" //7
];
// начальный массив для опций фиттинга
var FIT_OPTION_LIST_INI = FIT_OPTION_LIST;
// индекс для опции фиттинга "Specified content scaling"
var FIT_SCALING_INDEX = 6;
// индекс для опции фиттинга "Specified content size"
var FIT_SIZE_INDEX = 7;
// максимальное количество опций фиттинга
var FIT_OPTION_MAX = FIT_OPTION_LIST.length;
// начальное значение для опций фиттинга
var FIT_OPTION_INI = 5;
// текущее значение опции фиттинга
var FIT_CURRENT = FIT_OPTION_INI;
// значение опции фиттинга если выбраны 
// "Specified content scaling" или "Specified content size"
var FIT_SCALE_SIZE = FIT_OPTION_INI;
// текстовое значение для опций фиттинга
var FIT_TEXT = "";
// начальное текстовое значение для опций фиттинга в диалоге
var FIT_TEXT_INI = "Fitting: ";
// начальные значения для масштабирования
var W_SCALE_INI = "100";// по горизонтали (для ширины)
var H_SCALE_INI = "100";// по вертикали (для высоты)
// значения для масштабирования в главном диалоге
var W_SCALE = 100.0;// по горизонтали (для ширины)
var H_SCALE = 100.0;// по вертикали (для высоты)
// начальные значения для размеров
var W_SIZE_INI = "10";// по горизонтали (для ширины)
var H_SIZE_INI = "10";// по вертикали (для высоты)
// значения для размеров в главном диалоге
var W_SIZE = 10.0;// по горизонтали (для ширины)
var H_SIZE = 10.0;// по вертикали (для высоты)
// единицы измерения в документе
var H_UNITS;// по горизонтали (для ширины)
var V_UNITS;// по вертикали (для высоты)
// текстовые обозначения единиц измерения
var H_UNITS_TEXT = "";// по горизонтали
var V_UNITS_TEXT = "";// по вертикали
// начальные единицы измерения в документе
var H_UNITS_INI;// по горизонтали (для ширины)
var V_UNITS_INI;// по вертикали (для высоты)
// список текстовых значений для единиц для версий CS3 и CS4
var UN_TEXT_LIST = 
[
	"mm",// 0
	"cm",// 1
	"pt",// 2
	"in",// 3
	"ind",// 4
	"pc",// 5
	"ci",// 6
	"ag"// 7
];
// список "разрешенных" единиц для версий CS3 и CS4
var UN_LIST =
[
	MeasurementUnits.MILLIMETERS,// 0
	MeasurementUnits.CENTIMETERS,// 1
	MeasurementUnits.POINTS,// 2
	MeasurementUnits.INCHES,// 3
	MeasurementUnits.INCHES_DECIMAL,// 4
	MeasurementUnits.PICAS,// 5
	MeasurementUnits.CICEROS,// 6
	MeasurementUnits.AGATES// 7
];
// начальные значения для единиц
var H_UNITS_DROP_INI = 0;// по горизонтали
var V_UNITS_DROP_INI = 0;// по вертикали
// единицы выбранные в диалоге
var H_UN;
var V_UN;
// менялись ли единицы измерения
var UN_CHANGED = false;
// неподходящие единицы измерения
var BAD_UNITS = false;
// результат текстового ввода
var INP_OK = true;
// центрировать изображение после помещения
var CENTER;
// текст для опции центрировать изображение после помещения
var CENTER_TEXT = "Center images after placement";
// смещение контента
var SHIFT;
// текст для опции смещение контента
var SHIFT_TEXT = "";
// начальные значения смещений
var DX_INI = "0";
var DY_INI = "0";
// смещение из диалога
var DX = 0.;
var DY = 0.;
// выход без выполнения опреации
var NO_OPERATION = true;
// массив фреймов в выделении
var FRAMES_IN_SEL = new Array();
// массив выделенных объектов
var the_sel = new Array();
// в выделении заблокированные фреймы
var LOCKED_IN_SEL = false;
// обрабатывать ли заблокированные фреймы
var PROC_LOCK = false;
// текст для опции обрабатывать ли заблокированные фреймы
var PROC_LOCK_TEXT = "Process locked frames";
// есть ли открытые пути в объектах для обработки
var OBJ_OPEN_PATH = false;
// обрабатывать ли объекты c открытыми путями
var PROC_OPEN_PATH = false;
// текст для опции обрабатывать ли объекты c открытыми путями
var PROC_OPEN_PATH_TEXT = "Process frames with open paths";
// имеются НЕпустые фреймы
var CONT = false;
var CONT_REPLACE = false;
var CONT_REPLACE_TEXT = "Replace existing content";
// число фреймов
var N_F = 0;
// текст для числа фреймов
var N_F_TEXT = "Frames to be processed in the selection: ";
// заголовок для диалога выбора файла
var DIAL_CHOOSE_TEXT = "Choose a graphic file to place";
// текст запроса на продолжение выбора
var FILE_NOT_CHOSEN_TEXT = "File to place is not chosen! Quit?";
// текст запроса для НЕграфического файла
var NON_GRAPH_TEXT = "Likely the chosen file is not an image!\nContinue?";
// список пригодных для операции объектов
var OBJ_NAME_LIST = 
[
	"Rectangle",
	"Oval",
	"Polygon"	
];
// список подходящих расширений для файлов изображений
var EXT_LIST = 
[
	".psd",
	".pdf",
	".indd",
	".tif",
	".gif",
	".jpg",
	".bmp",
	".eps",
	".ai",
	".dcs",
	".pict",
	".wmf",
	".pcx",
	".png",
	".sct"
];
// версия приложения новее CS4
var VER_CS5 = false;
// текст для кнопки ОК в основном диалоге
var OK_BTN_TEXT = "Choose file to place";
//
// вызов основного модуля
main();
//
// основной модуль
function main()
{
	CHECK_SEL();
	if(!DIALOG_INI()) exit();
	READ_FILE();
	if( !PLACE ) exit();
	OPERATION();
};// end main
//
// ***** ПОДПРОГРАММА ВВОДА ИМЕНИ ФАЙЛА
function READ_FILE() 
{
	PLACE = true;
	do 
	{
		// получаем файл из диалога выбора
		FILE = File.openDialog( DIAL_CHOOSE_TEXT );
		// если из диалога не получен файл считаем что файл не выбран
		if( FILE == null ) 
		{
			// запрос на продолжение выбора
			if ( confirm( FILE_NOT_CHOSEN_TEXT ) == true ) 
			{
				PLACE = false;
				break;
			};// if
			continue;
		};// if
		// путь файла для помещения
		FILE_PATH = FIX_PATH( unescape( FILE.fsName ) ); 
		// имя файла для помещения
		FILE_NAME = unescape( GET_NAME_FROM_PATH( FILE_PATH  ) );
		// сокращенное имя файла для помещения
		FILE_NAME_SHORT = SHORT_NAME( FILE_NAME, D_NAME_LEN ) 
		//проверяем тип выбранного файла по расширению
		if( ! EXT_OK( FILE_NAME ) )
		{
			// запрос на продолжение если файл не графический
			var CONF_STR_EXT = NON_GRAPH_TEXT;
			if( !confirm (CONF_STR_EXT) ) continue;
		};// if
		// проверяем не являются ли документ и файл для помещения одним и тем же
		// если документ сохранен и имеет путь
		if( AD_SAVED )
		{
			// если совпали пути документа и файла для помещения
			if( AD_PATH == unescape(FILE.fullName) )
			{
				// предупреждение
				alert
				(
					"Warning: \n\n" +
					"The chosen file to place\n" +
					"and the document file are the same!\n" +
					"Current version "+ VERSION +" of the script\n"+
					"сan not process that :("
				);
				// выход
				exit();
			};// if			
		};// if
		// формируем строку для запроса на начало операции
		var CONF_STR =  
		TITLE + "\n"+
		"Options confirmation\n\n"+
		SETTINGS_STR()+"\n\n"+
		"Place?";
		// выводим запрос на начало операции
		if (confirm(CONF_STR) == false) 
		{
			PLACE = false; 
			return;
		};// if
		return;
	} 
	while (true);
	return;
};// end READ_FILE
//
// подпрограмма вывода параметров из главного диалога для подтверждения
function SETTINGS_STR()
{
	var S = 
	"Document: " + D_NAME +"\n\n"+
	"File to place name: "+ FILE_NAME+"\n"+
	FILE_PATH+"\n\n"+
	N_F_TEXT + N_F.toString() + "\n";
	if( CONT )
	{
		S = S + CONT_REPLACE_TEXT + "\n";
	};// if
	if( LOCKED_IN_SEL )
	{
		S = S + PROC_LOCK_TEXT + "\n";
	};// if
	if( OBJ_OPEN_PATH )
	{
		S = S + PROC_OPEN_PATH_TEXT + "\n";
	};// if
	S = S +
	MODE_TEXT+"\n"+
	SHOW_PLACEMENT_OPTIONS_TEXT + "\n"+
	FIT_TEXT + "\n" +
	CENTER_TEXT + "\n" +
	SHIFT_TEXT;
	return S;
};// end SETTINGS_STR
//
// подпрограмма создания блока для ввода размеров
function DIM_IN (where, b_name, b_name_len, name_1, ini_1, un_1, name_2, ini_2, un_2 )
{
	// создаем строку для всех объектов
	var the_line = where.add('group');
	the_line.orientation = 'row';
	the_line.alignChildren = 'left';
	// название
	if( the_name != "" )
	{
		var the_name = the_line.add('statictext');
		the_name.text = b_name;
		the_name.characters = b_name_len;
	};// if
	// длина поля ввода
	var data_len = WM( 46, 46 );
	// первое поле
	var f_1 = NUM_FIELD( the_line, name_1, ini_1, data_len, un_1 );
	// второе поле
	var f_2 = NUM_FIELD( the_line, name_2, ini_2, data_len, un_2 );
	return [ f_1[0], f_2[0], f_1[1], f_2[1] ];
};// end DIM_IN
//
// подпрограмма ввода размера или масштабирования 
// для помещаемого изображения
function SIZE_IN_DIAL( b_name, type )
{
	var d = new Window('dialog');
	d.text =TITLE; // заголовок диалога
	d.orientation = 'column';
	d.alignChildren = 'center';
	var mp = d.add('panel');
	b_name = b_name +":";
	// если тип данных проценты
	if( type == "%" ) 
	{
		var b_name_len = WM( 20, 20 );
		var ini_1 = W_SCALE_INI;
		var un_1 = "%";
		var ini_2 = H_SCALE_INI;
		var un_2 = "%";
	}
	// если тип данных размер
	else
	{
		var b_name_len = WM( 18, 18 );
		var ini_1 = W_SIZE_INI;
		var un_1 = H_UNITS_TEXT;
		var ini_2 = H_SIZE_INI;
		var un_2 = V_UNITS_TEXT;
	};//if-else
	var S = DIM_IN ( mp , b_name, b_name_len, "Width:", ini_1, un_1, "Height:", ini_2, un_2 );
	//
	// создание панели кнопок (кнопка ОК, кнопка Cancel)
	var okPanel = d.add('group');
	okPanel.orientation = 'row';
	// кнопка ОК
	var okBtn = okPanel.add('button', undefined, 'OK');
	// кнопка ОК неактивна, пока не выбран файл для помещения
	// кнопка Cancel
	var cancelBtn = okPanel.add('button', undefined, 'Cancel');
	// выводим основной диалог на экран
	var BUTTON = d.show();
	// нажимался ли ОК в диалоге
	var OK_PRESSED = false;
	// если нажато ОК
	if( BUTTON == 1 )
	{
		OK_PRESSED = true;
		// проверка ввода для процентов
		if( type == "%" )
		{
			if
			( 
				// если проценты меньше 0 или больше 100
				(TEXT_TO_DIGIT (S[0].text) > 100.) || (TEXT_TO_DIGIT (S[1].text) > 100.) ||
				(TEXT_TO_DIGIT (S[0].text) <= 0.) || (TEXT_TO_DIGIT (S[1].text) <= 0.)
			)
			{
				alert("Bad scaling input!");
				OK_PRESSED = false;
			};// if
		}
		// проверка ввода для размера
		else
		{
			// если размер меньше 0
			if( (TEXT_TO_DIGIT (S[0].text) <= 0.) || (TEXT_TO_DIGIT (S[1].text) <= 0.) )
			{
				alert("Bad size input!");
				OK_PRESSED = false;
			};// if
		};// if
	};// if-else
	// возвращаем: нажималась ли кнопка ОК и числа из полей ввода
	return [ OK_PRESSED, parseFloat( (TEXT_TO_DIGIT( S[0].text).toString() ) ), parseFloat( (TEXT_TO_DIGIT( S[1].text).toString() ) )];
};// end SIZE_IN_DIAL
//
// подпрограмма создания поля текстового ввода для числа
function NUM_FIELD( where, name, ini_data, data_len, un_text )
{
	// создаем строку для всех объектов
	var the_line = where.add('group');
	the_line.orientation = 'row';
	the_line.alignChildren = 'left';
	// название
	var the_name = the_line.add('statictext');
	the_name.text = name;
	// поле ввода
	var data_field = the_line.add('edittext');
	data_field.text = ini_data;
	data_field.preferredSize.width = data_len;
	data_field.onChanging = data_field_onChanging;
	//
	// подпрограмма реакции на процесс ввода числа в поле
	function data_field_onChanging()
	{
		digit_on_Changing( data_field, ini_data, ini_data );
		return;
	};// end data_field_onChanging
	// единицы после поля ввода (если они заданы)
	var un = undefined;
	if( un_text != "" )
	{
		var un = the_line.add('statictext');
		un.text = un_text;
		un.characters = WM( 3, 3 );
	};// if
	return [data_field, un];
};// end NUM_FIELD
//
// обработка поля ввода в процессе ввода
function digit_on_Changing(et, def, emp) 
{
	var s =et.text;
	if( s == "") 
	{
		et.text = emp;
		return;
	};
	if( !INP_OK ) 
	{
		et.text = def;
		INP_OK = true;
		return;
	}
	var d;
	var BNP = false;
	var N_C = 0;
	var N_P = 0;
	var N_M = 0;
	for( var i=0; i < s.length; i++ ) 
	{
		var si = s[i];
		if( si == "." || si == "," ) N_C = N_C +1;
		if( si == "-" ) N_M = N_M +1;
		if( si == "+" ) N_P = N_P +1;
		if
			( 
			((si != "-" && si != "+" && si != "." && si != "," && NO_DIGIT_SYMBOL(si)) || N_C>1 ) ||
			((N_P + N_M)>1) ||
			( si == "-"  && i !=0 ) ||
			( si == "+"  && i !=0 )
			) 
		{
			BNP = true;
			et.active = true;
			INP_OK = false;
			alert("Bad number input!");
			et.text = def;
			return;
		};// if
	};// for
	return;
};// end digit_on_Changing
//
// подпрограмма определения является ли символ цифрой
function NO_DIGIT_SYMBOL( s ) 
{
	try
	{
		if( s!= "0" && s!= "1" && s!= "2" && s!= "3" && s!= "4" && 
			 s!= "5" && s!= "6" && s!= "7" && s!= "8" && s!= "9") return true;
	} catch( error ) {};
	return false;
};// end NO_DIGIT_SYMBOL
//
// функция чтения текстового ввода и перевода в число
function TEXT_TO_DIGIT ( txt ) 
{
	var s = "";
	// если пусто то ноль
	if( txt == "" ) s = "0";
	if( txt == "+" ) s = "0";
	if( txt == "-" ) s = "0";
	var only_space = true;
	for( var i=0; i < txt.length; i++ ) 
	{
		if( txt[i] != " " ) only_space = false;
		if( txt[i] == ",") s = s + "." else s = s + txt[i];
	};// for
	// если только пробелы то ноль
	if( only_space ) s = "0";
	if( s == ".")  s = "0";
	if( s == "-")  s = "0";
	var s1 = "";
	for( var i=0; i < s.length; i++ ) 
	{
		if( s[i] == " " ) continue;
		s1 = s1 + s[i];
	};// for
	var d = parseFloat( s1 );
	return d;
};// end TEXT_TO_DIGIT
// подпрограмма изменения вариантов выбора
// в дропдауне
function REFILL_DROP( d, arr, ini, sep )
{
	// удаляем все старые варианты
	for( var i=d.items.length; i >= 0; i-- )
	{
		try
		{
			d.remove(  d.items[i]  );
		} catch ( error ) {};
	};// for
	// заполняем новыми вариантами
	for( var i=0; i < arr.length; i++ ) 
	{
		d.add( 'item', arr[i] );
	};// for
	// если задан текст для варианта после разделителя
	if( sep !="" )
	{
		// создаем разделитель
		d.add( 'separator' );
		// добавляем пункт после разделителя
		d.add( 'item', sep );
	};//if
	// присваиваем начальный вариант
	d.selection = ini;
	return;
};// end REFILL_DROP
//
// подпрограмма создания дропдауна
function IN_DATA_DROP( where, name, data_arr, extra, data_ini, dd_text_len, dd_len )
{
	var the_line = where.add('group');
	// создаем строку
	the_line.orientation = 'row';
	the_line.alignChildren = 'left';
	// название
	var the_name = the_line.add('statictext');
	the_name.text = name;
	the_name.characters = dd_text_len;
	// создаем дропдаун
	var dr = the_line.add('dropdownlist');
	for( var i=0; i < data_arr.length; i++ )
	{
		dr.add( 'item', data_arr[i] );
	};// for
	// добавляем разделитель если он задан
	if( extra != "" )
	{
		dr.add( 'separator' );
		dr.add( 'item', extra );
	};// if
	DDW( dr, dd_len );
	dr.selection = data_ini;
	return dr;
};// end IN_DATA_DROP
//
// подпрограмма назначения ширины дропдауна
function DDW( d, w )
{
	d.minimumSize.width =
	d.maximumSize.width = w;
	return;
};// end DDW
//
// ***** ПОДПРОГРАММА ОТОБРАЖЕНИЯ начального ДИАЛОГА
function DIALOG_INI() 
{
	dlg = new Window('dialog');
	dlg.text = TITLE;
	// основная панель
	var mp = dlg.add('panel');
	mp.alignChildren = 'left';
	//
	// подпрограмма создания статического текста
	function TEXT( txt )
	{
		var t = mp.add('statictext');
		t.text = txt;
		return t;
	};// end TEXT
	//
	// подпрограмма создания чекбокса
	function CB( ini, txt )
	{
		var c = mp.add('checkbox');
		c.text = txt;
		c.value = ini;
		return c;
	};// end CB
	//
	// подпрограмма создания дропдауна с текстом
	function DDT( txt_len, txt, arr, ini, d_len )
	{
		var g = mp.add('group');
		var t = g.add('statictext');
		t.text = txt;
		var sh = WM( 1, 0 );
		t.characters = txt_len + sh;
		var d = g.add('dropdownlist');
		for( var i=0; i<arr.length; i++ ) d.add('item', arr[i] );
		d.selection = ini;
		d.maximumSize.width =
		d.minimumSize.width = d_len;
		return d;
	};// end DDT
	//
	var HEAD_TEXT_LEN = WM( 270, 287 );
	// выводим название документа
	TEXT( "Document: " + D_NAME_SHORT ).maximumSize.width = HEAD_TEXT_LEN;
	// выводим количество фреймов в выделении
	TEXT( N_F_TEXT + N_F.toString() ).maximumSize.width = HEAD_TEXT_LEN;
	//
	// если есть заблокированные фреймы в выделении
	if( LOCKED_IN_SEL )
	{
		// обрабатывать ли заблокированные фреймы
		PROC_LOCK = CB( false, PROC_LOCK_TEXT );
	};// if
	//
	// если есть в выделении есть фреймы с открытыми путями
	if( OBJ_OPEN_PATH )
	{
		// обрабатывать ли фреймы с открытыми путями
		PROC_OPEN_PATH = CB( false, PROC_OPEN_PATH_TEXT );
	};// if
	// если в выделении есть не пустые фреймы
	if( CONT )
	{
		// заменять ли существующее содержимое
		CONT_REPLACE = CB( false, CONT_REPLACE_TEXT );
	};// if
	//
	// выбор режима выполнения
	MODE = DDT( WM(11, 12), MODE_TEXT, MODE_LIST, MODE_INI, WM( 173, 173 ) );
	//
	// показывать ли опции помещения
	SHOW_PLACEMENT_OPTIONS = CB( true, SHOW_PLACEMENT_OPTIONS_TEXT );
	// 
	// дополнительные настройки фиттинга
	FIT = DDT( WM(5, 6), FIT_TEXT_INI, FIT_OPTION_LIST_INI, FIT_OPTION_INI, WM( 215, 227 ) );
	// подпрограмма реакции на измение выбора режима
	FIT.onChange = function()
	{
		// подпрограмма для контроля и коррекции
		// состава списка опций фиттинга
		function RESET_FIT_OPTION_LIST()
		{
			// если длина списка больше максимальной
			// (то есть в списке присутствует разделитель и дополнительный пункт)
			if( FIT_OPTION_LIST.length > FIT_OPTION_MAX )
			{
				// сокращаем список до стандартного размера
				// временный массив для временного хранения
				var LIST = FIT_OPTION_LIST;
				// очищаем старый список
				FIT_OPTION_LIST = null;
				for( i=0; i < FIT_OPTION_MAX; i++ ) 
				{
					// перезаполняем из временного массива
					FIT_OPTION_LIST[ i ] = FIT_OPTION_LIST_INI[ i ];
				};// for
			};// if
			return;
		};// end RESET_FIT_OPTION_LIST
		// индекс опции
		var N = FIT.selection.index;
		// если совпал с текущим значением (т.е. не изменился)
		// тогда сразу выход
		if( N == FIT_CURRENT ) return;
		// запоминаем текущее значение опции
		FIT_CURRENT = N;
		// проверяем длину списка
		RESET_FIT_OPTION_LIST();
		// если выбран ввод масштаба или размера
		if( (N == FIT_SCALING_INDEX) || (N == FIT_SIZE_INDEX) )
		{
			// получаем конкрентное значение выбора
			FIT_SCALE_SIZE = N;
			// текстовая строка для диалога ввода значений
			FIT_TEXT = FIT_OPTION_LIST[ N ];
			// индекс для выделения пункта со значениями
			var N_SPEC = FIT_SCALING_INDEX+3;
			// если выбрано масштабирование
			if( N == FIT_SCALING_INDEX )
			{
				var N_TO_FIXED = 3;
				// вызываем диалог ввода значений для масштабирования
				var SIZE_DATA = SIZE_IN_DIAL( FIT_TEXT, "%" );
				try
				{
					var SIZE_IN_DIAL_OK = SIZE_DATA[0];
					var W = SIZE_DATA[1];
					var H = SIZE_DATA[2];
				} catch ( error ){};
				// если в диалоге ввода масштаба нажато ОК
				if( SIZE_IN_DIAL_OK )
				{
					// строка для дропдауна с масштабированием
					FIT_TEXT = 
					"W: "+ W.toFixed(N_TO_FIXED).toString() + "% "+
					"H: "+H.toFixed(N_TO_FIXED).toString()+ "%";
					// значения для масштабирования
					W_SCALE = W;
					H_SCALE = H;
					// новые начальные значения для масштабирования
					W_SCALE_INI = W.toString();
					H_SCALE_INI = H.toString();
				}
				// если в диалоге был нажат Cancel 
				// или был некорректный ввод масштабирования
				else
				{
					// присваиваем выбору опций фиттинга значение по умолчанию
					FIT.selection = FIT_OPTION_INI;
					return;
				};// if-else
			};// if N == FIT_SCALING_INDEX
			// если выбран размер
			if( N == FIT_SIZE_INDEX )
			{
				var N_TO_FIXED = 4;
				// вызываем диалог ввода значений для размера
				var SIZE_DATA = SIZE_IN_DIAL( FIT_TEXT, "size" );
				try
				{
					var SIZE_IN_DIAL_OK = SIZE_DATA[0];
					var W = SIZE_DATA[1];
					var H = SIZE_DATA[2];
				} catch ( error ){};
				// если в диалоге ввода значений нажато ОК
				if( SIZE_IN_DIAL_OK )
				{
					// строка для дропдауна с размерами
					FIT_TEXT = 
					"W: "+ W.toFixed(N_TO_FIXED).toString() + " " + H_UNITS_TEXT+ " " +
					"H: "+ H.toFixed(N_TO_FIXED).toString()+ " " +V_UNITS_TEXT;
					// значения для размеров
					W_SIZE = W;
					H_SIZE = H;
					// новые начальные значения для размеров
					W_SIZE_INI = W.toString();
					H_SIZE_INI = H.toString();
				}
				// если в диалоге был нажат Cancel 
				// или был некорректный ввод размера
				else
				{
					// присваиваем выбору опций фиттинга значение по умолчанию
					FIT.selection = FIT_OPTION_INI;
					return;
				};// if-else
			};// if N == FIT_SIZE_INDEX
			// добавляем в список опций пункт для значений масштабирования или размера
			// и делаем его выделенным
			REFILL_DROP( FIT, FIT_OPTION_LIST, N_SPEC, FIT_TEXT );
			return;
		};// if	
		// если опция не связана с вводом значений
		if( N < FIT_SCALING_INDEX )
		{
			// перезаполняем дропдаун без конкретных значений
			// для масштабирования или размера
			REFILL_DROP( FIT, FIT_OPTION_LIST_INI, N, "" );
		};// if
		//
		return;
	};// end FIT_onChange
	//
	// центрировать ли новые изображения
	CENTER = CB( true, CENTER_TEXT );
	// если некоторые идиницы измерения не разрешены
	if( BAD_UNITS )
	{ 
		// создаем панель выбора разрешенных единиц  измерения
		var UN_LINE = mp.add('group');
		UN_LINE.orientation = 'row';
		UN_LINE.alignChildren = 'left';
		var UN_DROP_LEN = WM( 52, 63 );
		H_UN = IN_DATA_DROP( UN_LINE, ("Units: " + WM("horizontal:", "horiz.:")), UN_TEXT_LIST, "", H_UNITS_DROP_INI, WM(13, 9), UN_DROP_LEN );
		H_UN.onChange = H_UN_onChange;
		V_UN = IN_DATA_DROP( UN_LINE, "vertical:", UN_TEXT_LIST, "", V_UNITS_DROP_INI, WM(6, 6), UN_DROP_LEN );
		V_UN.onChange = V_UN_onChange;
	};//if
	//
	// смещения изображений
	SHIFT = DIM_IN ( mp, "Shifts:", WM(5, 5), "dx:", DX_INI, H_UNITS_TEXT, "dy:", DY_INI, V_UNITS_TEXT );
	// 
	// подпрограмма реакции на смену горизонтальных единиц
	function H_UN_onChange()
	{
		var N = H_UN.selection.index;
		H_UNITS_TEXT = SHIFT[2].text = UN_TEXT_LIST[N];
		// если в настройках фиттинга задан размер вызываем диалог для подтверждения размера
		if( (FIT.selection.index == 9) && (FIT_SCALE_SIZE == 7) ) FIT.selection = 7;
		return;
	};// end H_UN_onChange
	// 
	// подпрограмма реакции на смену вертикальных единиц
	function V_UN_onChange()
	{
		var N = V_UN.selection.index;
		V_UNITS_TEXT = SHIFT[3].text = UN_TEXT_LIST[N];
		// если в настройках фиттинга задан размер вызываем диалог для подтверждения размера
		if( (FIT.selection.index == 9) && (FIT_SCALE_SIZE == 7) ) FIT.selection = 7;
		return;
	};// end H_UN_onChange
	//
	// подпрограмма деактивации / активации списка
	function DROP_ACTIVE_DEACTIVE( the_drop, act ) 
	{
		var NA;
		if( !act ) 
		{
			if( !the_drop.enabled ) return;
			NA = the_drop.add('item', "N/A");
			NA.selected = true;
			the_drop.enabled = false;
		} 
		else 
		{
			try 
			{
				if( the_drop.enabled ) return;
				the_drop.remove(  the_drop.items[the_drop.items.length-1]  );
				the_drop.items[0].selected = true;
				the_drop.enabled = true;
			} catch ( error ) {};
		};// if
		return;
	};// end DROP_ACTIVE_DEACTIVE
	//
	// создание панели кнопок (кнопка ОК, кнопка Cancel)
	var okPanel = dlg.add('group');
	okPanel.orientation = 'row';
	var okBtn = okPanel.add('button', undefined, OK_BTN_TEXT );// кнопка ОК
	dlg.defaultElement = okBtn;
	var cancelBtn = okPanel.add('button', undefined, 'Cancel');// кнопка Cancel
	// собственно показываем окно диалога
	var DIALOG_BUTTON = dlg.show();
	// если нажали ОК
	if (DIALOG_BUTTON == 1) 
	{
		if( LOCKED_IN_SEL )
		{
			PROC_LOCK = PROC_LOCK.value;
			PROC_LOCK_TEXT = PROC_LOCK_TEXT + ": "+ YN( PROC_LOCK );
		};// if
		if( OBJ_OPEN_PATH )
		{
			PROC_OPEN_PATH = PROC_OPEN_PATH.value;
			PROC_OPEN_PATH_TEXT = PROC_OPEN_PATH_TEXT + ": "+ YN( PROC_OPEN_PATH );
		};// if
		if( CONT )
		{
			CONT_REPLACE = CONT_REPLACE.value;
			CONT_REPLACE_TEXT = CONT_REPLACE_TEXT + ": " + YN( CONT_REPLACE );
		};// if
		SHOW_PLACEMENT_OPTIONS = SHOW_PLACEMENT_OPTIONS.value;
		SHOW_PLACEMENT_OPTIONS_TEXT = SHOW_PLACEMENT_OPTIONS_TEXT + ": "+ YN( SHOW_PLACEMENT_OPTIONS );
		MODE_TEXT = MODE_TEXT + MODE.selection.text;
		MODE = MODE.selection.index;
		if( MODE == 0 ) AUTO = false
		else AUTO = true; 
		FIT_TEXT = FIT.selection.text;
		FIT = FIT.selection.index;
		if( FIT > FIT_OPTION_MAX )
		{
			FIT_TEXT = FIT_TEXT_INI + FIT_OPTION_LIST[ FIT_SCALE_SIZE ]+" "+FIT_TEXT;
		}
		else
		{
			 FIT_TEXT = FIT_TEXT_INI + FIT_TEXT;
		};// if-else
		CENTER = CENTER.value;
		CENTER_TEXT = CENTER_TEXT + ": "+ YN( CENTER );
		DX = TEXT_TO_DIGIT( SHIFT[0].text );
		DY = TEXT_TO_DIGIT( SHIFT[1].text );
		// возможный ввод единиц измерения
		if( BAD_UNITS )
		{ 
			// значения дропдаунов выбора единиц
			H_UN = H_UN.selection.index;
			V_UN = V_UN.selection.index;
			// устанавливаем выбранные единицы для документа
			H_UNITS = AD.viewPreferences.horizontalMeasurementUnits = UN_LIST[ H_UN ];
			V_UNITS =AD.viewPreferences.verticalMeasurementUnits = UN_LIST[ V_UN ];
			// текстовые значения для единиц измерения
			H_UNITS_TEXT = UN_TEXT_LIST[ H_UN ];
			V_UNITS_TEXT = UN_TEXT_LIST[ V_UN ];
			// единицы менялись (чтобы потом восствновить старые)
			UN_CHANGED = true;
		};// if
		SHIFT_TEXT = "Shifts: dx: "+ DX.toFixed(4).toString() + " " +H_UNITS_TEXT+"  dy: " + DY.toFixed(4).toString() + " " + V_UNITS_TEXT;
		return true;
	};// if OK
	// если нажали Cancel
	if (DIALOG_BUTTON == 2) return false;
};// end DIALOG_INI
//
// подпрограмма перевода логического 
// значения в текстовый вид
function YN( x)
{
	if( x ) return "Yes"
	else return "No";
};// end YN
//
//
// ***** ПОДПРОГРАММА ИСПРАВЛЕНИЯ ПУТИ
// ***** убираем двоеточия для МАКа
function FIX_PATH(p) 
{
	if( WFS ) return p;
	fp = "";
	for( var i=0; i < p.length; i++ )
	{
		var p_i = p[i];
		if( p_i == ":" )
		{
			fp = fp + "/";
			continue;
		};// if
		fp = fp + p_i;
	};// for
	return fp;
};// end FIX_PATH
//
// ******** ПОДПРОГРАММА снятия выделения
function DESELECT_ALL() 
{
	try
	{
		app.select( null );
	} catch ( error ) {};
	return;
};// end DESELECT_ALL
//
// ******** ПОДПРОГРАММА ОТОБРАЖЕНИЯ АКТИВНОГО ОБЪЕКТА
function zoomObject( the_obj ) 
{
	CAN_SHOW = true;
	try 
	{
		var obj_bounds = the_obj.geometricBounds;
		var obj_height = obj_bounds[2] - obj_bounds[0];
		var obj_width = obj_bounds[3] - obj_bounds[1];
		var AW = app.activeWindow;
		var page_bounds = AW.activePage.bounds;
		var page_height = page_bounds[2] - page_bounds[0];
		var page_width = page_bounds[3] - page_bounds[1];
		var h_ratio  = page_height / obj_height;
		var w_ratio = page_width / obj_width;
		var zoomRatio = Math.min( h_ratio, w_ratio );
		app.select( the_obj, SelectionOptions.replaceWith );
		AW.zoom( ZoomOptions.fitPage );
		AW.zoomPercentage = AW.zoomPercentage * zoomRatio;
	}
	catch ( error ) 
	{
		CAN_SHOW = false;
	};// try-catch
	return;
};// end zoomObject
//
//  подпрограмма диалога для пошагового режима
function DIAL_STEP( obj_found, i ) 
{
	zoomObject( obj_found );
	with(myDialog2 = app.dialogs.add({name:TITLE, canCancel:false}))
	{
		with(dialogColumns.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:"Document: "+D_NAME_SHORT});
			dialogRows.add().staticTexts.add({staticLabel:"File name: "+FILE_NAME_SHORT});
			if( !CAN_SHOW )
			{ 
				dialogRows.add().staticTexts.add({staticLabel:"Can not show the frame!"});
				dialogRows.add().staticTexts.add({staticLabel:" "});
			};// if
			with( WHAT2 = radiobuttonGroups.add())
			{
				radiobuttonControls.add({staticLabel:"Place", checkedState:true});
				radiobuttonControls.add({staticLabel:"Skip"});
				radiobuttonControls.add({staticLabel:"Quit operation"});
			};// with
		};// with
		myDialog2.show();
	};// with
	WHAT2 = WHAT2.selectedButton;
	myDialog2.destroy();
	// обрабатываем фрейм
	if(WHAT2 == 0) 
	{
		PLACE_DIAL_STEP = true;
		return;
	};// if
	// пропускаем фрейм
	if(WHAT2 == 1) 
	{
		N_SKIP++;
		PLACE_DIAL_STEP = false;
		return;
	};// if
	// выход из опрации
	if(WHAT2 == 2) 
	{
		QUIT_BY_USER = true;
		RESTORE_LOCK( obj_found, obj_locked );
		the_exit();
	};// if
	return;
};// end DIAL_STEP
//
// подпрограмма разблокирования объекта
function UNLOCK( the_obj )
{
	try
	{
		// разблокируем объект
		the_obj.locked = false;
	}
	// если ошибка считаем что он в заблокированной группе
	catch ( error )
	{
		// родительский объект
		var the_parent = the_obj.parent;
		// если дошли до уровня документа выход
		if( the_parent.constructor.name == "Document" ) return;
		// пытаемся разблокировать родительский объект
		UNLOCK( the_obj.parent );
	};// try-catch
	return;
};// end UNLOCK
//
// подпрограмма восстановления заблокированного состояния объекта
function RESTORE_LOCK( the_obj, L )
{
	try
	{
		if( L ) the_obj.locked = true;
	} catch ( error ) {};
	return;
};// end RESTORE_LOCK
//
// ******** ПОДПРОГРАММА размещения файла в выделенных фреймах
function OPERATION() 
{
	NO_OPERATION = false;
	// помещаемый файл ПДФ
	var PLACE_PDF = false;
	// помещаемый файл документ ИнДизайна
	var PLACE_PAGE = false;
	// номер помещаемой страницы для многостраничного документа
	var PN;
	// graphicLayerOptions для помещаемого изображения
	var GL = new Array();
	// количество слоев
	var GL_LEN = 0;
	//
	// подпрограмма получения помещенного изображения во фрейме
	function GET_IMAGE( F )
	{
		try
		{
			return F.allGraphics[0];
		} 
		catch ( error )
		{
			N_ERR++;
		};// try-catch		
	};// end GET_IMAGE
	//
	// цикл по выделенным фреймам
	var NF_MINUS_1 = N_F - 1;
	for( var i = NF_MINUS_1; i >= 0; i--)
	{
		// текущий фрейм
		var F_i = FRAMES_IN_SEL[i];
		// текущий фрейм заблокирован
		var F_i_locked = F_i.locked;
		// текущий фрейм имеет открытые пути
		var F_i_has_open_paths =  HAS_OPEN_PATHS( F_i );
		// текущий фрейм НЕпустой
		var F_i_not_empty = NOT_EMPTY ( F_i );
		// если есть ли открытые пути и нет обработки открытых путей
		if( F_i_has_open_paths && !PROC_OPEN_PATH )
		{
			// пропускаем
			N_SKIP++;
			continue;
		};// if
		// если объект заблокирован и нет обработки заблокированных
		if( F_i_locked && !PROC_LOCK )
		{
			// пропускаем
			N_SKIP++;
			continue;
		};// if
		// если объект НЕпустой и нет замещения существующего содержимого
		if( F_i_not_empty && !CONT_REPLACE )
		{
			// пропускаем
			N_SKIP++;
			continue;
		};// if
		// ID текущего фрейма
		var F_i_ID = F_i.id;
		// 
		if( AUTO )
		{
			if( i == NF_MINUS_1 && SHOW_PLACEMENT_OPTIONS ) SHOW_PLACEMENT_OPTIONS = true
			else SHOW_PLACEMENT_OPTIONS = false;
		};// if
		try
		{
			// если автоматическое размещение
			if( AUTO )
			{
				try
				{
					// присваиваем номер страницы для помещенного изображения
					// ( для многостраничных файлов )
					if( i != NF_MINUS_1 )
					{
						// для PDF
						if( PLACE_PDF ) app.pdfPlacePreferences.pageNumber = PN;
						// для помещенных страниц InDesign
						if( PLACE_PAGE ) app.importedPageAttributes.pageNumber = PN;
					};// if
					// если фрейм был заблокирован разблокируем
					if( F_i_locked ) UNLOCK( F_i );
					// помещаем
					F_i.place( FILE, SHOW_PLACEMENT_OPTIONS );
					// переопределяем фрейм
					F_i = AD.pageItems.itemByID( F_i_ID );
					// помещенное изображение
					var G = GET_IMAGE( F_i );
					if( i == NF_MINUS_1 )
					{
						// проверяем видимость слоев если они есть
						// запоминаем видимость слоев для первого фрейма
						if( G.hasOwnProperty("graphicLayerOptions") )
						{
							GL_LEN = G.graphicLayerOptions.graphicLayers.length;
							for( var j = 0; j < GL_LEN; j++ )
							{
								GL[j] = G.graphicLayerOptions.graphicLayers[j].currentVisibility;
							};// for j
						};// if
						// проверяем на первом фрейме какой тип файлов помещаем
						// если PDF
						if( G.constructor.name == "PDF" ) 
						{
							PLACE_PDF = true;
						};// if
						// если страница InDesign
						if( G.constructor.name == "ImportedPage" ) 
						{
							PLACE_PAGE = true;
						};// if
						// если PDF или страница InDesign 
						if( PLACE_PDF || PLACE_PAGE )
						{
							// определяем номер помещенной страницы
							PN = G.pdfAttributes.pageNumber;
						};// if
					};// if
					// присваиваем видимость слоев для последующих фреймов
					if( i != NF_MINUS_1 && G.hasOwnProperty("graphicLayerOptions") )
					{
						for( var j = 0; j < GL_LEN; j++ )
						{
							var LAYERS = G.graphicLayerOptions.graphicLayers;
							if( LAYERS[j].currentVisibility != GL[j] ) LAYERS[j].currentVisibility = GL[j];
						};// for j
					};// if
					N_PLACED++;
				}
				catch ( error )
				{
					// если ошибка - считаем что в диалоге импорта нажато Cancel
					if( SHOW_PLACEMENT_OPTIONS ) { N_SKIP++; QUIT_BY_USER = true }
					else N_ERR++;
					RESTORE_LOCK( F_i, F_i_locked );
					the_exit();
				};// try-catch
			}
			// если пошаговое размещение
			else
			{
				// выводим диалог для пошагового режима
				DIAL_STEP( F_i, NF_MINUS_1 - i +1 );
				// если дана команда на помещение из пошагового диалога
				if( PLACE_DIAL_STEP ) 
				{
					try
					{
						// если фрейм был заблокирован разблокируем
						if( F_i_locked ) UNLOCK( F_i );
						// помещаем
						F_i.place( FILE, SHOW_PLACEMENT_OPTIONS );
						// помещенное изображение
						var G = GET_IMAGE( F_i );
						N_PLACED++;
					}
					catch ( error )
					{
						// если ошибка - считаем что в диалоге импорта нажато Cancel
						if( SHOW_PLACEMENT_OPTIONS ) N_SKIP++
						else N_ERR++;
						// восстанавливаем блокировку
						RESTORE_LOCK( F_i, F_i_locked );
						continue;
					};// try-catch
				}
				// если нет команды на помещение во фрейм
				else
				{
					// восстанавливаем блокировку
					RESTORE_LOCK( F_i, F_i_locked );
					continue;
				};// if-else
			};// if-else
		}
		catch ( error )
		{
			// восстанавливаем блокировку
			RESTORE_LOCK( F_i, F_i_locked );
			continue;
		};// try-catch
		// выполнение фиттинга
		SET_FIT( FIT, G );
		// пермещение изображения
		MOVE( G, DX, DY );
		// восстанавливаем блокировку
		RESTORE_LOCK( F_i, F_i_locked );
	};// for
	the_exit();
};// end OPERATION
//
// подпрограмма перемещения изображения
function MOVE( obj, dx, dy )
{
	// если заданные перемещения = 0 сразу выход
	if( (dx == 0.) && (dy == 0.) ) return;
	try
	{
		// собственно перемещение объекта
		obj.move(undefined, [dx, dy]);
	}
	catch ( error ) 
	{
		N_ERR++;
	};// try-catch
	return;
};// end MOVE
//
// подпрограмма выполнения фиттинга
function SET_FIT( N, G )
{
	try
	{
		// если заданы настройки для размера или масштабирования
		if( N > FIT_OPTION_MAX )
		{
			N = FIT_SCALE_SIZE;
		};// if
		// use preference settings
		if( N == 0 ) 
		{ 
			// сразу выходим, ничего не делаем
			return;
		};// if 0
		// fit content to frame
		if( N == 1 ) 
		{
			G.fit( FitOptions.CONTENT_TO_FRAME );
		};// if 1
		// fit content to frame proportionally
		if( N == 2 ) 
		{
			G.fit( FitOptions.PROPORTIONALLY );
		};// if 2
		// fit frame to content
		if( N == 3 )
		{
			G.fit( FitOptions.FRAME_TO_CONTENT );
		};// if 3
		// fill frame proportionally
		if( N == 4 )
		{
			G.fit( FitOptions.FILL_PROPORTIONALLY );
		};// if 4
		// 100% content scaling
		if( N == 5 ) 
		{
			SCALE( G, 100., 100. );
		};// if 5
		// specified content scaling
		if( N == 6 ) 
		{
			SCALE( G, W_SCALE, H_SCALE );
		};// if 6
		// specified content size
		if( N == 7 ) 
		{
			SIZE( G, W_SIZE, H_SIZE );
		};// if 7
		// выполнение центрирования
		if( CENTER )
		{
			G.fit( FitOptions.CENTER_CONTENT );
		};// if
		//
		// подпрограмма ввода нового размера
		function SIZE( G, S_W, S_H )
		{
			// если версия CS5 и новее
			if( VER_CS5 )
			{
				// подпрограмма получения пунктов
				function PT( x, u )
				{
					// если единицы пункты сразу возврат исходного значения
					if( u == 2054188905 ) return x;
					// если единицы измерения НЕ агаты
					if (u != 2051106676 )
					{
						// если цицеро
						if( u == 2053335395 )
						{
							return x * 12.78788;
						};// if
						// переводим цифры размеров в единицы измерения документа
						// если НЕ десятичные дюймы
						if( u != 2053729892 )
						{
							var a = new UnitValue(x, u );
						}
						// если десятичные дюймы 
						else
						{
							// корректируем
							var a = new UnitValue(x, MeasurementUnits.INCHES );
						};// if-else
						// переводим размеры в пункты для функции трансформации
						a = a.as("pt");
					}
					else
					// если единицы агаты
					{
						//  корректируем
						var a = (x /14. ) * 72.;
					};// if-else
					return a;
				};// end PT
				//
				// пространство координат
				var the_cs = CoordinateSpaces.INNER_COORDINATES;
				// центр трансформации: левый верхний угол фрейма
				var the_ancor = AnchorPoint.TOP_LEFT_ANCHOR;
				// заменять старые значения размеров
				var the_rm = ResizeMethods.REPLACING_CURRENT_DIMENSIONS_WITH;
				// получаем пункты из значений в диалоге
				var H_VAL = PT(S_W, H_UNITS );
				var V_VAL = PT(S_H, V_UNITS );
				// размеры как массив для ввода
				var the_size = [ H_VAL, V_VAL ];
				G.resize
				(
					the_cs, // пространство координат
					the_ancor, // центр трансформации
					the_rm, // заменять старые значения размеров
					the_size,// размеры как массив
					true, // трансформировать объекты по отдельности (а он и так один :)))
					false // ввод размеров в пунктах
				);
			}
			// если версия CS4 и старше
			else
			{
				// попдпрограмма перевода в пункты из текстового значения единиц
				function PT_UN_TEXT( x, u )
				{
					// если единицы пункты сразу возврат
					if( u == "pt" ) return x;
					// если единицы НЕ агаты
					if( u != "ag" )
					{
						// если цицеро
						if( u == "ci" )
						{
							return x * 12.78788;
						};// if
						// если НЕ десятичные дюймы
						if( u != "ind" )
						{
							var a = new UnitValue(x, u );
						}
						// если десятичные дюймы 
						else
						{
							// корректируем
							var a = new UnitValue(x, "in" );
						};// if-else
						a = a.as("pt");
					}
					// если единицы агаты
					else
					{
						//  корректируем
						var a = (x /14. ) * 72.;
					};// if-else
					return a;
				};// end PT_UN_TEXT
				//
				// сначала ставим масштаб 100%
				SCALE( G, 100., 100. );
				//получаем начальный размер изображения в пунктах
				var the_size = G.resolve( AnchorPoint.BOTTOM_RIGHT_ANCHOR, CoordinateSpaces.INNER_COORDINATES, false );
				// переводим координаты в текст
				the_size = the_size + "";
				// ширина из координат (текст)
				var the_w = "";
				// высота из координат (текст)
				var the_h = "";
				// дошли до запятой в координатах
				var comma = false;
				// цикл по символам текста координат
				for( var i = 0; i < the_size.length; i++ )
				{
					// текущий символ
					var d = the_size[i];
					// если получена запятая
					if( d == "," )
					{
						comma = true;
						continue;
					};// if
					// до запятой получаем ширину
					if( !comma )
					{
						the_w = the_w + d;
					}
					// после запятой получаем высоту
					else
					{
						the_h = the_h + d;
					};// if-else
				};// for
				// переводим старые размеры из текста в число
				the_w = parseFloat( the_w );
				the_h = parseFloat( the_h );
				// переводим цифры новых размеров в единицы измерения документа
				// для ранних версий используем текстовые значения для единиц
				var H_VAL = PT_UN_TEXT( S_W, H_UNITS_TEXT );
				var V_VAL = PT_UN_TEXT( S_H, V_UNITS_TEXT );
				// рассчитываем масштабирование для получения нового заданного размера
				var d_w = ( H_VAL / the_w ) * 100.;
				var d_h = ( V_VAL / the_h ) * 100.;
				// масштабируем для получения новых размеров
				SCALE( G, d_w, d_h );
			};// if-else
			return;
		};// end SIZE
		//
		// подпрограмма масштабирования
		function SCALE( G, S_W, S_H )
		{
			// пространство координат
			var the_cs = CoordinateSpaces.PARENT_COORDINATES;
			// центр трансформации: левый верхний угол фрейма
			var the_ancor = AnchorPoint.TOP_LEFT_ANCHOR
			//  матрица трансформаций для масштабирования
			var the_scale = app.transformationMatrices.add({ horizontalScaleFactor: S_W*0.01,  verticalScaleFactor: S_H*0.01 });
			// собственно трансформация
			G.transform
			(
				the_cs, // пространство координат
				the_ancor, // центр трансформации
				the_scale, //  матрица трансформаций для масштабирования
				MatrixContent.SCALE_VALUES, // замещение возможных прошлых трансформаций
				true // учитывать единицы измерений
			);
			return;					
		};// end SCALE
	}
	catch ( error )
	{
		N_ERR++;
	};// try-catch
	return;
};// end SET_FIT
//
// ******** ПОДПРОГРАММА вывода результатов выполнения операции
function REPORT()
{
	if( NO_OPERATION ) return;
	var S_PLACED = "Placed: "+ N_PLACED + "\n";
	var S_SKIP ="";  if ( N_SKIP > 0 ) S_SKIP = "Skipped: " + N_SKIP + "\n";
	var S_ERR = "Errors: " + N_ERR + "\n";
	var S_QBU =""; if ( QUIT_BY_USER ) S_QBU = "\nOperation was interrupted\n";
	alert
	(
		TITLE + "\n"+
		"Report\n\n"+
		SETTINGS_STR()+"\n\n"+
		S_PLACED+
		S_SKIP+
		S_ERR+
		S_QBU
	);
	return;
};// end REPORT
//
// функция восстановления первоначального вида окна программы
function RESTORE_VIEW() 
{
	app.activeWindow.activeSpread = AS;
	BEGIN_WINDOW.zoom(ZoomOptions.fitSpread);
	if( BAD_UNITS )
	{
		RESTORE_UNITS();
	};// if
	return;
};// end RESTORE_VIEW
//
// подпрограмма проверки наличия открытых путей в объекте
function HAS_OPEN_PATHS( the_obj )
{
	try
	{
		// цикл по путям объекта
		for( var j = 0; j < the_obj.paths.length; j++ )
		{
			// если путь объекта открытый
			if( the_obj.paths[j].pathType == PathType.OPEN_PATH )
			{
				// в объекте есть открытые пути
				return true;
			};// if
		};// for
	} catch ( error ) {};
	return false;
};// end HAS_OPEN_PATHS
//
// подпрограмма проверки является ли фрейм пустым
function NOT_EMPTY( the_obj )
{
	// подпрограмма проверки имеются ли объекты
	function HAS_OBJECTS( arr )
	{
		try
		{
			if( arr.length > 0 ) return true;
		} catch ( error ) {};
		return false;
	};// end HAS_OBJECTS
	//
	if( HAS_OBJECTS( the_obj.pageItems ) ) return true;
	if( HAS_OBJECTS( the_obj.allPageItems ) ) return true;
	if( HAS_OBJECTS( the_obj.allGraphics ) ) return true;
	return false;
};// end NOT_EMPTY
// подпрограмма получения геометрических границ объекта
function GBOUNDS( the_obj )
{
	// результат операции
	var OK = false;
	// границы
	var b;
	try
	{
		// получаем геометрические границы
		b = the_obj.geometricBounds;
		// если удалось получить без ошибки
		OK = true;
	}
	catch ( error ) {};// try-catch
	// возвращаем результат операции и геометрические границы
	return [OK, b];
};// end GBOUNDS
//
// подпрограмма поиска фреймов в объекте
function FIND_FRAMES ( the_arr)
{
	// подпрограмма проверки находится ли объект уже в выходном массиве
	// obj - проверяемый объект
	// the_arr - массив, принадлежность к которому проверяется
	function IS_IN_ARR( obj, the_arr )
	{
		// ID проверяемого объекта
		var the_obj_id = obj.id;
		// цикл по объектам массива
		for( var i = 0; i < the_arr.length; i++ )
		{
			// если совпали ID значит объект уже в массиве
			if( the_obj_id == the_arr[i].id ) return true;
		};// for
		// если не было совпадений ID значит объект не в массиве
		return false;
	};// end IS_IN_ARR
	//
	// подпрограмма проверки имени объекта
	function NAME_OK( the_obj )
	{
		// имя объекта
		var the_name = the_obj.constructor.name;
		// цикл по списку объектов которые могут быть фреймами
		for( var i = 0; i < OBJ_NAME_LIST.length; i++ )
		{
			// если имя объекта совпало с именем из списка
			if( the_name == OBJ_NAME_LIST[i] )
			{
				// значит объект является фреймом
				return true;
			};// if
		};// for
		// если объект графическая линия
		if( the_name == "GraphicLine")
		{
			// но с замкнутым путем (контуром)
			if( !HAS_OPEN_PATHS( the_obj ) )
			{
				// значит объект является фреймом
				return true;
			};// if
		};// if	
		return false;
	};// end NAME_OK
	//
	// цикл по выделенным объектам
	for( var i =0; i < the_arr.length; i++ )
	{
		// текущий объект
		var the_obj = the_arr[i];
		// родитель текущего объекта
		var the_obj_parent = the_obj.parent;
		// если объект внутри фрейма пропускаем этот объект
		if( NAME_OK( the_obj_parent ) ) continue;
		// проверка по наличию границ
		// если не удалось получить границы пропускаем этот объект
		if( !GBOUNDS( the_obj )[0] ) continue;
		// проверка по имени если объект может быть фреймом
		if( NAME_OK( the_obj ) )
		{
			// если объект еще не в выходном массиве объектов
			if( !IS_IN_ARR( the_obj, FRAMES_IN_SEL ) )
			{
				// заносим объект в выходной массив объектов
				FRAMES_IN_SEL.push( the_obj );
				// проверяем заблокирован ли объект
				if(  !LOCKED_IN_SEL )
				{
					if( the_obj.locked ) LOCKED_IN_SEL = true;
				};// if
				// проверяем есть ли открытые пути
				if( !OBJ_OPEN_PATH )
				{
					if( HAS_OPEN_PATHS( the_obj ) ) OBJ_OPEN_PATH = true;
				};// if
				// проверяем пустой ли фрейм
				if( !CONT )
				{
					if( NOT_EMPTY (the_obj) ) CONT = true;
				};// if
				continue;
			};// if
		}
		// если имя не соответствует фрейму
		else
		{
			// поиск по подобъектам внутри объекта
			// массив всех подобъектов
			var sub_objects = new Array();
			//
			// подпрограмма добавления подобъектов определенных типов
			// в общий массив подобъектов
			function GET_SUB_OJECTS( arr )
			{
				try
				{
					for( var j=0; j < arr.length; j++ ) 
					{
						// добавление в общий массив подобъектов
						sub_objects.push( arr[j] );
					};// for
				} catch ( error ) {};// try-catch
				return;
			};// end GET_SUB_OJECTS
			//
			// добавляем прямоугольники
			GET_SUB_OJECTS( the_obj.rectangles );
			// добавляем овалы
			GET_SUB_OJECTS( the_obj.ovals );
			// добавляем многоугольники
			GET_SUB_OJECTS( the_obj.polygons );
			// добавляем графические линии
			GET_SUB_OJECTS( the_obj.graphicLines );
			// добавляем группы
			GET_SUB_OJECTS( the_obj.groups );
			// обрабатываем полученный массив подобъектов 
			FIND_FRAMES ( sub_objects );
		};// if-else
	};// for
	return;
};// end FIND_FRAMES
//
// подпрограмма поиска графики в выделении
function CHECK_SEL()
{
	// есть ли открытые документы
	if( app.documents.length == 0 )
	{
		alert("There are no open documents!");
		exit();
	};// if
	// проверяем версию индизайна
	var the_app_version = parseInt(app.version);
	// если версия индизайна старше CS3
	if( the_app_version <= 4 )
	{
		alert("Please use InDesign CS3 or newer!");
		exit();
	};// if
	// если версия индизайна новее CS4
	if( the_app_version >= 7 ) VER_CS5 = true;
	// определяем файловую систему
	if(File.fs == "Windows") WFS = true; 
	// активный документ
	AD = app.activeDocument; 
	D_NAME_LEN = WM( 20, 23 );
	// имя активного документа
	D_NAME = AD.name;
	// имя активного документа для диалога
	D_NAME_SHORT = SHORT_NAME( D_NAME, D_NAME_LEN ); 
	// был ли сохранен активный докмент
	AD_SAVED = AD.saved;
	// путь активного документа (если он был сохранен)
	if( AD_SAVED )
	{
		AD_PATH = unescape(File(AD.fullName).fullName);
	};// if
	// ссылка на акт. разворот
	AS = app.activeWindow.activeSpread; 	
	// начальное окно (для восстановления)
	BEGIN_WINDOW = app.activeWindow; 
	// выделение в документе
	the_sel = AD.selection;
	// если нет выделения
	if( the_sel.length == 0 )
	{
		alert("There are no selected objects!");
		exit();
	};// if
	// если выделены направляющие
	if(  the_sel[0].constructor.name == "Guide" )
	{
		alert("Guides are selected! Can not process this!");
		exit();
	};// if
	// поиск графических фреймов в выделении
	FIND_FRAMES( the_sel );
	// количество графических фреймов в выделении
	N_F = FRAMES_IN_SEL.length;
	// если не найдено подходящих графических фреймов в выделении
	if( N_F == 0 )
	{
		alert("There are no frames to be processed in the selection!")
		exit();
	};// if
	// получаем единицы измерения в документе и заодно запоминаем старые значения
	H_UNITS_INI = H_UNITS = AD.viewPreferences.horizontalMeasurementUnits;
	V_UNITS_INI = V_UNITS = AD.viewPreferences.verticalMeasurementUnits;
	// получаем текстовые обозначения единиц измерения
	H_UNITS_TEXT = GET_RULER_UNITS_TEXT( H_UNITS_INI );
	V_UNITS_TEXT = GET_RULER_UNITS_TEXT(V_UNITS_INI );
	// для CS4 и более ранние версии
	if( !VER_CS5 )
	{
		// единицы
		var H_UNITS_CHECK = UNITS_OK( H_UNITS );
		var H_UNITS_OK = H_UNITS_CHECK[ 0 ];
		H_UNITS_DROP_INI = H_UNITS_CHECK[ 1 ];
		var V_UNITS_CHECK = UNITS_OK( V_UNITS );
		var V_UNITS_OK = V_UNITS_CHECK[ 0 ];
		V_UNITS_DROP_INI = V_UNITS_CHECK[ 1 ];
		// проверяем соответствие единиц измерения документа "разрешенному" списку
		if( !H_UNITS_OK || !V_UNITS_OK )
		{
			// если хотя бы одни из единиц не соответсвуют 
			// считаем что требуется ввод единиц в диалоге
			BAD_UNITS = true;
			// получаем текстовые обозначения единиц измерения
			H_UNITS_TEXT = UN_TEXT_LIST[H_UNITS_DROP_INI];
			V_UNITS_TEXT = UN_TEXT_LIST[V_UNITS_DROP_INI];
		};// if
	};// if
	return;
};// end CHECK_SEL
//
// подпрограмма определения единиц для линеек документа
function GET_RULER_UNITS_TEXT(the_units) 
{
	switch ( the_units ) 
	{
		case (2054188905): return "pt";// points
		case (2054187363): return "pc";// picas
		case (2053729891): return "in";// inches
		case (2053729892): return "ind";// inches decimal
		case (2053991795): return "mm";// millimeters
		case (2053336435): return "cm";// centimeters
		case (2053335395): return "ci";// ciceros
		case (1131639917): return "pt";// custom
		case (2051106676): return "ag";// agates
		case (2054187384): return "px";// pixels
		default: return "??";
	};// switch
	return "??";
};// end GET_RULER_UNITS_TEXT;
//
function SHORT_NAME(txt, N) 
{
	if ( txt.length > N ) txt = txt.substr(0, N) + "...";
	return txt;
};// end SHORT_NAME
//
// подпрограмма получения имени из пути
function GET_NAME_FROM_PATH( P )
{
	var P_LEN = P.length;
	var NAME = "";
	for( var i = P_LEN -1; i >=0; i-- )
	{
		var C = P[i];
		if( C == "\\" || C == "/") break;
		NAME = C + NAME;
	};// for i
	return NAME;
};// end GET_NAME_FROM_PATH
//
// подпрограмма получения расширения файла и имени без расширения
function GET_EXT( N )
{
	// расширение на выходе
	var EXT = "";
	// только имя без расширения на выходе
	var N_ONLY = "";
	var STOP_EXT = false;
	// цикл по символам начиная с последнего
	for( var i = N.length-1; i >= 0; i-- )
	{
		var N_i = N[i];
		if( !STOP_EXT )
		{
			EXT = N_i + EXT;
			if( N_i == "." ) STOP_EXT = true;
			continue;
		};// if
	};// for
	return EXT;	
};// end GET_EXT
//
// подпрограмма проверки типа выбранного файла по расширению
function EXT_OK( name )
{
	// получаем расширение из имени
	var the_ext = GET_EXT( name );
	the_ext = the_ext.toLowerCase();
	for( var i=0; i < EXT_LIST.length; i++ )
	{
		if( the_ext == EXT_LIST[i] ) return true;
	};// for
	return false;
};// end EXT_OK
//
// подпрограмма проверки соответствия единиц измерения
// "разрешенному" списку
function UNITS_OK( the_units )
{
	for( var i = 0; i < UN_LIST.length; i++ )
	{
		if( the_units == UN_LIST[i] ) return [ true, i ];
	};// for
	return [false, 0 ];	
};// end UNITS_OK
//
// подпрограмма восстановления начальных единиц измерения
function RESTORE_UNITS()
{
	AD.viewPreferences.horizontalMeasurementUnits = H_UNITS_INI;
	AD.viewPreferences.verticalMeasurementUnits = V_UNITS_INI;
	return;
};// end RESTORE_UNITS
//
// подпрограмма завершения работы скрипта
function the_exit()
{
	REPORT();
	DESELECT_ALL();
	RESTORE_VIEW();
	exit();
};// end the_exit
//
// подпрограмма присвоения значения переменной
// в зависимости от файловой системы
function WM( W, M )
{
	// если Windows
	if( WFS ) return W
	// если Macintosh
	else return M;
};// end WM
